use crate::TaskLog;

pub async fn start(
    task_id: i32,
    pool: &sqlx::Pool<sqlx::Postgres>,
) -> Result<TaskLog, sqlx::Error> {
    sqlx::query_as!(
        TaskLog,
        "INSERT INTO logs (task_id, created_at, task_status) VALUES ($1, now(), 'pending') RETURNING task_id, log_id, created_at, task_status, finished_at",
        task_id
    )
    .fetch_one(pool)
    .await
}

pub async fn update(
    task_id: i32,
    task_status: String,
    pool: &sqlx::Pool<sqlx::Postgres>,
) -> Result<(), Box<dyn std::error::Error>> {
    let _ = sqlx::query_as!(
        TaskLog,
        "UPDATE logs SET task_status = $1 WHERE task_id = $2",
        task_status,
        task_id
    )
    .fetch_one(pool)
    .await;
    Ok(())
}
